/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package funambol.syncclient.blackberry.email.impl;
import java.util.Hashtable;
/**
 * <code>NotificationProcessor</code> class for processing notification message
 *
 * $Id: NotificationProcessor.java,v 1.0
 */

public class NotificationProcessor {

        private String digest                            = null  ;
        private String version                           = null  ;
        private char uiMode                              =   '\0';
        private char initiator                           =   '\0';
        private short sessionId                          =      0;
        private String serverId                          =  null ;
        private int numberOfSync                         =      0;
        private SyncInfo [] syncInfo                     =  null ;
        //constant sizes
        private static final int DIGEST_SIZE             =    128;
        private static final int VERSION_SIZE            =     10;
        private static final int UI_MODE_SIZE            =      2;
        private static final int INTITIATOR_SIZE         =      1;
        private static final int FUTURE_USE1_SIZE        =     27;
        private static final int SESSION_ID_SIZE         =     16;
        private static final int SERVER_IDENTIFIER_SIZE  =      8;
        private static final int NUM_SYNCS_SIZE          =      4;
        private static final int FUTURE_USE2_SIZE        =      4;
        private static final int SYNC_TYPE_SIZE          =      4;
        private static final int FUTURE_USE3_SIZE        =      4;
        private static final int CONTENT_TYPE_SIZE       =     24;
        private static final int SERVER_URI_SIZE         =      8;
        private final  int ERR_NOT_AUTHENTICATION        =      1;
        private final int ERR_NOT_PARSER                 =      2;


    public NotificationProcessor() {


          }


     /**
     * adds a servId:clientId String to store .
     * @param Hashtable:  hashtable this is the hastable to be filled with information
     * @return int :0 if sucess else return error code
     */

public int processMessage(Hashtable hashtable,String NotificationMessage){

try
{
    String binaryMessage = "";

    String temp ="";


    byte [] notificationByteArray =  NotificationMessage.getBytes();



            for(int i = 0; i < notificationByteArray.length; i++) {

                    byte c = notificationByteArray[i]; // Get next character

                    temp = Integer.toString( ( c & 0xff ) + 0x100, 2 /* radix */ ).substring( 1 );

                    binaryMessage+=temp;

            }




            //actual processing and fill ups
            int arrayPointer =0;

            digest =  binaryMessage.substring(arrayPointer,arrayPointer+DIGEST_SIZE);

            hashtable.put("Digest",digest);

            arrayPointer+= DIGEST_SIZE;



            //version
            version = binaryMessage.substring(arrayPointer,arrayPointer+VERSION_SIZE);
            
            double ver =(double) Integer.parseInt(version,2);
            
            ver = ver/10.0;
            
            version = Double.toString(ver);
            
            hashtable.put("Version",version);

            arrayPointer+=VERSION_SIZE;



            // ui mode;
            String uimode = binaryMessage.substring(arrayPointer,arrayPointer+UI_MODE_SIZE);
            int ui_mode = Integer.parseInt(uimode,2);
            
            uiMode = Integer.toString(ui_mode).charAt(0);
            
            
            hashtable.put("UiMode",new Integer(uiMode));
            
            
            arrayPointer+=UI_MODE_SIZE;



            //initiator
            String initiator_s = binaryMessage.substring(arrayPointer,arrayPointer+INTITIATOR_SIZE);
            
            int initiator_i = Integer.parseInt(initiator_s,2);
            
            initiator = Integer.toString(initiator_i).charAt(0);
            
            hashtable.put("Initiator",new Integer(initiator));
            
            arrayPointer+= INTITIATOR_SIZE;



            //future-use
            arrayPointer+=FUTURE_USE1_SIZE;



            //session-id
            String ses_id = binaryMessage.substring(arrayPointer,arrayPointer+SESSION_ID_SIZE);
            
            sessionId = new Integer(Integer.parseInt(ses_id,2)).shortValue();
            
            hashtable.put("SessionId",new Short(sessionId));
            
            arrayPointer+=SESSION_ID_SIZE;



            //server-identifier-len
            String servidlen =binaryMessage.substring(arrayPointer,arrayPointer+SERVER_IDENTIFIER_SIZE);
            
            int serverid_len =Integer.parseInt(servidlen,2);
            
            arrayPointer+=SERVER_IDENTIFIER_SIZE;
            


            //server-identifier
            //process each-byte
            for(int k =0;k<serverid_len;k++){

                    temp=  binaryMessage.substring(arrayPointer,arrayPointer+8);

                    int oneByte =  Integer.parseInt(temp,2);

                    serverId+=(char)oneByte;

                    arrayPointer+=8;
            }
            
            hashtable.put("ServerId",serverId);



            //no of syncs
            numberOfSync= Integer.parseInt(binaryMessage.substring(arrayPointer,arrayPointer+NUM_SYNCS_SIZE),2);

            hashtable.put("NumberOfSync",new Integer(numberOfSync));

            arrayPointer+=NUM_SYNCS_SIZE;


            //future use
            arrayPointer+= FUTURE_USE2_SIZE;


            //loop now no of syncs time(s)
            syncInfo = new SyncInfo[numberOfSync];


            for(int p= 0;p<numberOfSync;p++){

                syncInfo[p]=new  SyncInfo();

                int syncType=  Integer.parseInt(binaryMessage.substring(arrayPointer,arrayPointer+SYNC_TYPE_SIZE),2);

                syncType+=200;

                syncInfo[p].setSyncType(syncType);

                arrayPointer+= SYNC_TYPE_SIZE;



                //future use
                arrayPointer+= FUTURE_USE3_SIZE;




                //content type
                int contentTypei;

                String contentType="";

                    for( int o=0;o<CONTENT_TYPE_SIZE/8;o++) {


                                contentTypei =Integer.parseInt(binaryMessage.substring(arrayPointer,arrayPointer+8),2);

                                contentType = Integer.toString(contentTypei);

                                arrayPointer+=8;

                    }
                    syncInfo[p].setContentType(contentType);




                    //server uri-length
                    int serverurl_len = Integer.parseInt(binaryMessage.substring(arrayPointer,arrayPointer+SERVER_URI_SIZE),2);


                    arrayPointer+=SERVER_URI_SIZE;




                    //server uri
                    String serverUri="";
                    for(int k =0;k<serverurl_len;k++){


                                String byteData=  binaryMessage.substring(arrayPointer,arrayPointer+8);

                                int oneByte =  Integer.parseInt(byteData,2);

                                serverUri+=(char)oneByte;

                                arrayPointer+=8;
                    }
                    syncInfo[p].setServerUri(serverUri);


                    hashtable.put("syncInfo["+p+"]",syncInfo[p]);

            }
    }catch(Exception e ){

        return  ERR_NOT_PARSER;
    }

return 0;

}




}


/**
 * <code>SyncInfo</code> class for storing sync information parsed from notification message
 *
 *@author Sailesh email:sailesh@telibrahma.com
 * $Id: SyncInfo.java,v 1.0
 */
class SyncInfo {


        private int syncType                         =   0;
        private String contentType                   = null;
        private String serverUri                     = null;


        public SyncInfo(){
         }

        /**
        *  sets the int : syncType
        * @param int:  syncType sets sycType information parsed from notification message
        */

        public void setSyncType(int syncType){

            this.syncType =syncType;

            }
        /**
        *  sets the String : contentType
        * @param String:  contentType sets contentType information parsed from notification message
        */

        public void setContentType(String contentType){

                this.contentType =contentType;
            }

        /**
        *  sets the String : serverUri
        * @param String:  serverUri sets serverUri information parsed from notification message
        */

        public void setServerUri(String serverUri){

                this.serverUri = serverUri;

            }

    }





