/**
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package funambol.syncclient.blackberry.email.impl;

import java.io.*;
import net.rim.device.api.crypto.*;
import net.rim.device.api.util.DataBuffer;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import funambol.syncclient.util.StaticDataHelper;

/**
 * <code>Sync4jCrypto</code> Uses TripleDES Encryption & Decryption to encrypt & decrypt the data
 *
 * $Id: Sync4jCrypto.java,v 1.0
 */
public class Sync4jCrypto {
    TripleDESKey key;
  
    
    public Sync4jCrypto() {    
     key = new TripleDESKey();
         
    }
    public byte[] encryptData(String data){
        try{
            TripleDESEncryptorEngine encryptionEngine = new TripleDESEncryptorEngine( key );
            PKCS5FormatterEngine formatterEngine = new PKCS5FormatterEngine( encryptionEngine );
            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
            BlockEncryptor encryptor = new BlockEncryptor( formatterEngine, outputStream );
            // Encrypt the actual data.
            encryptor.write( data.getBytes() );
            encryptor.close();
            return outputStream.toByteArray();
        }catch( CryptoTokenException e ) {
            StaticDataHelper.log(e.toString());
        } catch (CryptoUnsupportedOperationException e) {
            StaticDataHelper.log(e.toString());
        } catch( IOException e ) {
            StaticDataHelper.log(e.toString());
        }
        return null;
    }
    
    public String decryptData(byte[] data){
        try{
            TripleDESDecryptorEngine decryptorEngine = new TripleDESDecryptorEngine( key );
            
            PKCS5UnformatterEngine unformatterEngine = new PKCS5UnformatterEngine( decryptorEngine );
            
            ByteArrayInputStream inputStream = new ByteArrayInputStream(data);
            
            BlockDecryptor decryptor = new BlockDecryptor( unformatterEngine, inputStream );
            
            byte[] read = new byte[10];
            DataBuffer databuffer = new DataBuffer();
            for( ;; ) {
                int bytesRead = decryptor.read( read );
                if( bytesRead <= 0 ) {
                    break;
                }
                databuffer.write(read, 0, bytesRead);
            }
            
            byte[] decryptedData = databuffer.toArray();
            return decryptedData.toString();
        }catch( CryptoTokenException e ) {
            StaticDataHelper.log(e.toString());
        } catch (CryptoUnsupportedOperationException e) {
            StaticDataHelper.log(e.toString());
        } catch( IOException e ) {
            StaticDataHelper.log(e.toString());
        }
        return null;
   
    }
    
} 
